Package io.vertx.core.http

## Interface ServerWebSocket

- All Superinterfaces:
    `ReadStream<Buffer>`, `StreamBase`, `WebSocket`, `WebSocketBase`, `WriteStream<Buffer>`

      public interface ServerWebSocket
      extends WebSocket

  Represents a server side WebSocket.

  Instances of this class are passed into a `HttpServer.webSocketHandler(io.vertx.core.Handler<io.vertx.core.http.ServerWebSocket>)` or provided when a WebSocket handshake is manually `HttpServerRequest.toWebSocket()`ed.

  Author:
    Tim Fox

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HostAndPort` | `authority()` |
    `default Future<Void>` | `close()` | Close the WebSocket sending the default close frame.
    `ServerWebSocket` | `closeHandler​(Handler<Void> handler)` | Set a close handler.
    `ServerWebSocket` | `drainHandler​(Handler<Void> handler)` | Set a drain handler on the stream.
    `ServerWebSocket` | `endHandler​(Handler<Void> endHandler)` | Set an end handler.
    `ServerWebSocket` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the read stream.
    `ServerWebSocket` | `fetch​(long amount)` | Fetch the specified `amount` of elements.
    `ServerWebSocket` | `frameHandler​(Handler<WebSocketFrame> handler)` | Set a frame handler on the connection.
    `ServerWebSocket` | `handler​(Handler<Buffer> handler)` | Set a data handler.
    `String` | `path()` |
    `ServerWebSocket` | `pause()` | Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `String` | `query()` |
    `default ServerWebSocket` | `resume()` | Resume reading, and sets the buffer in `flowing` mode.
    `String` | `scheme()` |
    `ServerWebSocket` | `setWriteQueueMaxSize​(int maxSize)` | Set the maximum size of the write queue to `maxSize`.
    `SSLSession` | `sslSession()` |
    `String` | `uri()` |

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `blockingStream, collect, pipe, pipeTo`

    - ### Methods inherited from interface io.vertx.core.http.WebSocket

      `binaryMessageHandler, pongHandler, shutdownHandler, textMessageHandler`

    - ### Methods inherited from interface io.vertx.core.http.WebSocketBase

      `binaryHandlerID, close, close, closeReason, closeStatusCode, end, headers, isClosed, isSsl, localAddress, peerCertificates, remoteAddress, shutdown, shutdown, shutdown, shutdown, shutdown, shutdown, subProtocol, textHandlerID, writeBinaryMessage, writeFinalBinaryFrame, writeFinalTextFrame, writeFrame, writePing, writePong, writeTextMessage`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, write, writeQueueFull`

- - ### Method Detail

    - #### exceptionHandler

          ServerWebSocket exceptionHandler​(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WebSocket`
      Specified by:
        `exceptionHandler` in interface `WebSocketBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          ServerWebSocket handler​(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Specified by:
        `handler` in interface `WebSocket`
      Specified by:
        `handler` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          ServerWebSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Specified by:
        `pause` in interface `WebSocket`
      Specified by:
        `pause` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          default ServerWebSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Specified by:
        `resume` in interface `WebSocket`
      Specified by:
        `resume` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          ServerWebSocket fetch​(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Specified by:
        `fetch` in interface `WebSocket`
      Specified by:
        `fetch` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          ServerWebSocket endHandler​(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `endHandler` in interface `WebSocket`
      Specified by:
        `endHandler` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          ServerWebSocket setWriteQueueMaxSize​(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WebSocket`
      Specified by:
        `setWriteQueueMaxSize` in interface `WebSocketBase`
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          ServerWebSocket drainHandler​(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WebSocket`
      Specified by:
        `drainHandler` in interface `WebSocketBase`
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### closeHandler

          ServerWebSocket closeHandler​(Handler<Void> handler)

      Description copied from interface: `WebSocketBase`
      Set a close handler. This will be called when the WebSocket is closed.

      After this callback, no more messages are expected. When the WebSocket received a close frame, the `WebSocketBase.closeStatusCode()` will return the status code and `WebSocketBase.closeReason()` will return the reason.
      Specified by:
        `closeHandler` in interface `WebSocket`
      Specified by:
        `closeHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          ServerWebSocket frameHandler​(Handler<WebSocketFrame> handler)

      Description copied from interface: `WebSocketBase`
      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Specified by:
        `frameHandler` in interface `WebSocket`
      Specified by:
        `frameHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### scheme

          String scheme()

      Returns:
        the WebSocket handshake scheme

    - #### authority

          HostAndPort authority()

      Returns:
        the WebSocket handshake authority

    - #### uri

          String uri()

    - #### path

          String path()

      Returns:
        the WebSocket handshake path.

    - #### query

          String query()

      Returns:
        the WebSocket handshake query string.

    - #### close

          default Future<Void> close()

      Close the WebSocket sending the default close frame.

      No more messages can be sent.

      The WebSocket handshake will be accepted when it hasn't yet been settled or when an asynchronous handshake is in progress.

      Specified by:
        `close` in interface `WebSocketBase`
      Returns:
        a future completed with the result

    - #### sslSession

          SSLSession sslSession()

      Specified by:
        `sslSession` in interface `WebSocketBase`
      Returns:
        SSLSession associated with the underlying socket. Returns null if connection is not SSL.
      See Also:
        `SSLSession`